#include <bits/stdc++.h>
using namespace std;

int main(){
	int n;
	cin>>n;
	vector<string> niske(n);
	for (int i=0;i<n;i++){
		int niska;
		cin>>niska;
	}

	int t[n][n];
	for (int i=0;i<n;i++){
		for (int j=0;j<n;j++){
		cin>>t[i][j];
	}
	}	
	/*vector<vector<int>>red(n,vector<int> (n));
	vector<vector<int>>kolona(n,vector<int> (n));
	
	for (int i=0;i<n;i++){
		for (int j=1;j<n;j++){
			red[i][j]+=red[i][j-1];
		
		}
	}
	for (int i=1;i<n;i++){
		for (int j=0;j<n;j++){
			kolona[i][j]+=kolona[i-1][j;
		
		}
	}
	*/
	int maks=0;
	for (int i=0;i<n;i++){
		for (int j=0;j<n;j++){
			maks+=max(t[i+1][j],t[i][j+1]);
			if(t[i+1][j]>t[i][j+1]){
				i+=1;
				break;
				cout<<i<<" "<<j<<endl;
			}
		}
	}
	cout<<maks+t[n-1][n-1];
	
}